package app18a.action;

import app18a.dao.CustomerDAO;
import app18a.dao.DAOFactory;
import app18a.form.CustomerForm;
import app18a.to.CustomerTO;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

public class CreateCustomerAction extends Action {

  public ActionForward execute(ActionMapping mapping, ActionForm form,
    HttpServletRequest request, HttpServletResponse response) {

    ActionMessages actionMessages = new ActionMessages();
      
  	CustomerForm customerForm = (CustomerForm) form;
    CustomerTO customerTO = new CustomerTO();

    // populate customerTO with the value of customerForm
    customerTO.setName(customerForm.getName());
    customerTO.setAddress(customerForm.getAddress());
    customerTO.setPhone(customerForm.getPhone());
    
    // insert customerTO into database
    CustomerDAO customerDAO = DAOFactory.getInstance().getCustomerDAO();
    try {
      customerDAO.createCustomer(customerTO);
      actionMessages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("success.add"));
      saveMessages(request, actionMessages);
      return (mapping.findForward("success"));
    }
    catch (Exception ex) {
      actionMessages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("failed.add"));
      saveMessages(request, actionMessages);
      return (mapping.findForward("failed"));
    }
       
  }
}
